; TIP1042.LSP: INAGIN.LSP    Insert Block to Match   (c)1994, Buddy Jenkins

;;; INsert same block AGaIN.LSP (inagin.lsp)

(defun INERR (s)
    (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")  
        (princ)
        (princ (strcat "\nError: " s))
     )
     (princ)
    )
    (princ "\n*Cancel*   INAGIN routine completed.   ")
    (if AWAL (redraw AWAL 4))
    (setvar "CLAYER" $CL)
    (setvar "ATTDIA" $AD)
    (setvar "AUNITS" $AU)
    (grtext)
    (setq *error* OLDERR)
    (princ))
;----------------------------------------------------------------------------

(defun c:in (/ $IN $CL $AD $AU LA BLKN BN NEWBL ANS $XS $YS $RA) 
    (setq OLDERR *error*)
    (setq *error* INERR)
(grtext 0 "BJ Macro")                (grtext 0 "BJ Macro" 1)
(grtext -1 " Harry's HOT TIP #IFGOOD, CADalyst, INAGIN.lsp by Buddy Jenkins. ") 
    (setq $IN (getvar "INSNAME"))
    (setq $CL (getvar "CLAYER"))
    (setq $AD (getvar "ATTDIA"))
    (setq $AU (getvar "AUNITS"))
    (setvar "ATTDIA" 1)
    (setvar "AUNITS" 4)

        (while (null BLKN)
                (setq BLKN (entsel "\nSelect block to insert:  "))
            (if BLKN
                (progn
                    (setq BLKN (car BLKN))
                    (if (/=
                            (cdr (assoc 0 (entget BLKN))) "INSERT")
                        (progn
                            (prompt "\That's not a block, it's a ")
                            (princ (cdr (assoc 0 (entget BLKN))))
                            (setq BLKN nil)
                        )
                    )
                    (if BLKN (redraw BLKN 3))
                )
                (exit)
            )
        )
    (setq BN (entget BLKN))
    (setq NEWBL (cdr (assoc 2 BN)))
    (setq $XS (cdr (assoc 41 BN)))
    (setq $YS (cdr (assoc 42 BN)))
    (setq $IP (cdr (assoc 10 BN)))
    (setq $RA (angtos (cdr (assoc 50 BN)) 4))
    (setq LA (cdr (assoc 8 BN)))
    (command ".layer" "s" LA "")
(grtext -1 "Insert another BLOCK at same scale, rot. & layer") 
    (while 
        (setq IP (getpoint $IP "\nPress Pick Button to DRAG block, <Done>:  "))
        (command  "_.insert" NEWBL $IP $XS $YS $RA)
        (prompt (strcat
            "\nSelect insertion point for \""NEWBL"\" block on layer "LA":  "))
        (command ".move" "L" "" $IP pause)
        (setq IP nil)
    )
    (prompt (strcat "\nDone.  Returned to previous layer "$CL" "))
    (command ".layer" "s" $CL "")
    (redraw BLKN 4)
    (setvar "ATTDIA" $AD)
    (setvar "AUNITS" $AU)
    (setq *error* OLDERR)
(grtext)
    (princ)
)
(prompt "\nInagin.lsp Loaded.  Inagin was last edit 28 JAN 94."  )
(prompt 
"\nType \"in\" to insert BLOCK at same scale, rot, lay. [Enter] to stop.")
(princ)
